/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, 2009, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <o2scl/binary_file.h>
#include <o2scl/test_mgr.h>

using namespace std;
using namespace o2scl;

int main(void) {
  def_err_hnd.set_mode(2);

  binary_out_file *bof=new binary_out_file("binary_file.dat");

  bof->bool_out(true);
  bof->char_out('x');
  bof->double_out(sqrt(2.0));
  bof->int_out(777);
  bof->word_out("word");
  bof->string_out("\tthis is a  string test");
  
  delete bof;
  
  cout << "Inputing." << endl;

  bool b;
  char c;
  double d;
  int i;
  string w, s;

  binary_in_file *bif=new binary_in_file("binary_file.dat");
  
  bif->bool_in(b);
  bif->char_in(c);
  bif->double_in(d);
  bif->int_in(i);
  bif->word_in(w);
  bif->string_in(s);

  delete bif;

  cout << b << endl;
  cout << c << endl;
  cout << d << endl;
  cout << i << endl;
  cout << w << endl;
  cout << s << endl;

  test_mgr t;
  t.set_output_level(2);

  t.report();

  return 0;
}

