/*
  -------------------------------------------------------------------

  Copyright (C) 2006, Andrew W. Steiner

  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  -------------------------------------------------------------------
*/
#include <o2scl/format_float.h>
#include <o2scl/test_mgr.h>

using namespace std;
using namespace o2scl;

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  format_float fd;
  fd.latex_mode();
  cout << fd.convert(2.0e16) << endl;
  fd.html_mode();
  cout << fd.convert(2.0e16) << endl;

  cout << endl;
  fd.latex_mode();
  cout << fd.convert(-sqrt(2.0)*1.0e-5) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-4) << endl;
  cout << fd.convert(-sqrt(2.0)*1.0e-3) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-2) << endl;
  cout << fd.convert(-sqrt(2.0)*1.0e-1) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e0) << endl;
  cout << fd.convert(-sqrt(2.0)*1.0e1) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e2) << endl;
  cout << fd.convert(-sqrt(2.0)*1.0e3) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e4) << endl;
  cout << fd.convert(-sqrt(2.0)*1.0e5) << endl;

  cout << endl;
  fd.set_sig_figs(3);
  cout << fd.convert(sqrt(2.0)*1.0e-5) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-2) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e0) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e2) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e5) << endl;
  fd.set_sig_figs(5);

  cout << endl;
  fd.html_mode();
  cout << fd.convert(sqrt(2.0)*1.0e-5) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-4) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-3) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-2) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e-1) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e0) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e1) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e2) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e3) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e4) << endl;
  cout << fd.convert(sqrt(2.0)*1.0e5) << endl;

  cout << endl;
  cout << "Show that final zeros don't work right now:" << endl;
  fd.set_sig_figs(7);
  cout << fd.convert((sqrt(2.0)-2.135e-4)*1.0e-5) << endl;
  
  t.report();
  return 0;
}

