/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, 2009, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <o2scl/eos.h>

using namespace std;
using namespace o2scl;

eos::eos() {
  eos_thermo=&def_thermo;
}

int eos::get_thermo(thermo *&th) {
  th=eos_thermo; 
  return gsl_success; 
}

int eos::set_thermo(thermo &th) {
  eos_thermo=&th;
  return gsl_success;
}

template<> int io_tlate<eos>::input
(cinput *co, in_file_format *ins, eos *ep) {
  /*
  bool sw;
  string tmp;
  ins->bool_in(sw,"thermo");
  if (sw) pointer_in(co,ins,((int *)(&ep->eos_thermo)),tmp);
  */
  return 0;
}

template<> int io_tlate<eos>::output
(coutput *co, out_file_format *outs, eos *ep) {
  /*
  if (ep->eos_thermo!=&ep->def_thermo) {
    outs->bool_out(true,"thermo");
    pointer_out(co,outs,ep->eos_thermo,ep->eos_thermo->type());
  } else {
    outs->bool_out(false,"thermo");
  }
  */
  return 0;
}

template<> const char *io_tlate<eos>::type() { return "eos"; }

