/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, 2008, 2009, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifndef O2SCL_EOS_IOC_H
#define O2SCL_EOS_IOC_H
#include <string>
#include <o2scl/apr_eos.h>
#include <o2scl/bag_eos.h>
#include <o2scl/gen_potential_eos.h>
#include <o2scl/nambujl_eos.h>
#include <o2scl/rmf_eos.h>
#include <o2scl/schematic_eos.h>
#include <o2scl/skyrme_eos.h>

#ifndef DOXYGENP
namespace o2scl {
#endif

  /** \brief Setup I/O objects for equation of state classes

      This class is experimental.
  */
  class eos_ioc {

  public:

    eos_ioc() {
      apr_eos_io=new apr_eos_io_type("apr_eos_io");
      bag_eos_io=new bag_eos_io_type("bag_eos_io");
      gen_potential_eos_io=new gen_potential_eos_io_type
	("gen_potential_eos_io");
      eos_io=new eos_io_type("eos_io");
      //hadronic_eos_io=new hadronic_eos_io_type("hadronic_eos_io");
      nambujl_eos_io=new nambujl_eos_io_type("nambujl_eos_io");
      quark_eos_io=new quark_eos_io_type("quark_eos_io");
      rmf_eos_io=new rmf_eos_io_type("rmf_eos_io");
      schematic_eos_io=new schematic_eos_io_type("schematic_eos_io");
      skyrme_eos_io=new skyrme_eos_io_type("skyrme_eos_io");
    }
    
    ~eos_ioc() {
      delete apr_eos_io;
      delete bag_eos_io;
      delete gen_potential_eos_io;
      delete eos_io;
      //delete hadronic_eos_io;
      delete nambujl_eos_io;
      delete quark_eos_io;
      delete rmf_eos_io;
      delete schematic_eos_io;
      delete skyrme_eos_io;
    }

    apr_eos_io_type *apr_eos_io;
    bag_eos_io_type *bag_eos_io;
    gen_potential_eos_io_type *gen_potential_eos_io;
    eos_io_type *eos_io;
    //hadronic_eos_io_type *hadronic_eos_io;
    nambujl_eos_io_type *nambujl_eos_io;
    quark_eos_io_type *quark_eos_io;
    rmf_eos_io_type *rmf_eos_io;
    schematic_eos_io_type *schematic_eos_io;
    skyrme_eos_io_type *skyrme_eos_io;
    
  protected:

#ifndef DOXYGENP

    //minimize_ioc m;
    //part_ioc p;

#endif
  
  };

#ifndef DOXYGENP
}
#endif

#endif
